<template>
  <div
    class="demo-navbar-user pl10 ml10 border-left pr"
    @mouseenter="openQuick"
    @mouseleave="closeQuick"
    v-show="newList.length"
  >
    <span class="cursor-pointer">应用中心</span>
    <div class="border-left quick-menu" :style="isOpenQuick?'height:100%;':'height:0%;'">
      <perfect-scrollbar
        :options="{ suppressScrollX: true, wheelPropagation: true }"
        class="clients-scroll"
      >
        <div class="quick-btn" :class="isOpenQuick?'active':''">应用中心</div>
        <ul>
          <li class="quick-item" v-for="(iteam,index) in newList" :key="index">
            <a
              href="javascript:void(0)"
              @click="openModule(iteam)"
              class="card card-hover text-dark my-2 pt5"
            >
              <img
                :src="`/static/img/application_center_icon/${iteam.state === 1?iteam.module:iteam.module+'_disabled'}.png`"
                :alt="iteam.module"
                :onerror="noneImg"
                width="50px"
              >
              <h5 class="mt-2 mb-2" :title="iteam.module">{{iteam.name}}</h5>
            </a>
          </li>
        </ul>
      </perfect-scrollbar>
    </div>
  </div>
</template>
<style src="@/vendor/styles/pages/clients.scss" lang="scss"></style>
<script>
import { mapActions } from 'vuex'
import { getApplicationList } from '@/server/common'
import PerfectScrollbar from '@/vendor/libs/perfect-scrollbar/PerfectScrollbar'
export default {
  name: 'quick-menu',
  data() {
    return {
      noneImg: 'this.src="' + require('@/assets/img/noneImg.png') + '"',
      userInfo: this.$store.getters.basicUserInfo,
      applicationList: [],
      isOpenQuick: false,
      timer: null
    }
  },
  computed: {
    newList() {
      return this.applicationList.reduce((list, item) => {
        if (item.state === 1 && item.module !== this.$store.state.menuName) {
          list.push(item)
        }
        return list
      }, [])
    }
  },
  methods: {
    ...mapActions(['openNewWindowtab']),
    /* 获取应用列表 */
    async getApplicationList() {
      let result = await getApplicationList({
        orgId: this.userInfo.orgId,
        userId: this.userInfo.id
      })
      if (result && !result.error) {
        this.applicationList = result
      } else if (result && result.msg) {
        this.$toast({
          message: result.msg ? result.msg : '报错了',
          type: 'error'
        })
      }
    },
    openModule(data) {
      if (!data || data.state !== 1) {
        return false
      }
      this.openNewWindowtab(data.url)
    },
    openQuick() {
      let count = 0
      clearInterval(this.timer)
      this.timer = setInterval(() => {
        count++
        if (count > 3) {
          if (!this.isOpenQuick && this.newList.length) {
            this.isOpenQuick = true
          }
        }
      }, 100)
    },
    closeQuick() {
      clearInterval(this.timer)
      if (this.isOpenQuick && this.newList.length) {
        this.isOpenQuick = false
      }
    }
  },
  created() {
    this.getApplicationList()
  },
  components: {
    PerfectScrollbar
  }
}
</script>
<style lang="scss" scoped >
.quick-btn {
  height: 65px;
  line-height: 50px;
  padding: 8px 10px;
  transition: all 0.5s;
  cursor: pointer;
}
.quick-btn.active {
  color: #fff;
  background-color: #28c3d7 !important;
}
.quick-menu {
  position: fixed;
  width: 100px;
  right: 0;
  top: 0px;
  transition: all 0.5s;
  height: 0;
  background: #f8f8f8;
  overflow: hidden;
}
.quick-menu ul,
li.quick-item {
  list-style: none;
  padding: 2px;
  margin: 0px;
}
.quick-item a {
  text-align: center;
  display: block;
}
</style>
